package foraging;

import bcn.coord.PriorityCoord;
import com.cyberbotics.webots.controller.Compass;
import com.cyberbotics.webots.controller.DifferentialWheels;
import com.cyberbotics.webots.controller.DistanceSensor;
import com.cyberbotics.webots.controller.GPS;


public class CtrlWanderRecharge extends foraging_stub.CtrlWanderRecharge_stub {
    
    static public void main(String[] args) {
        CtrlWanderRecharge controller = new CtrlWanderRecharge();
        controller.setupAndRun();
    }
    
    
    @Override
    public void setupAndRun() {
        DifferentialWheels robot = new DifferentialWheels();
        
        // init sensors
        DistanceSensor[] ds = new DistanceSensor[8];
        for (int i=0; i<ds.length; i++) {
            ds[i] = robot.getDistanceSensor("ds" + i);
            ds[i].enable(Misc.CONTROL_STEP);
        }
        robot.batterySensorEnable(Misc.CONTROL_STEP);
        GPS gps = robot.getGPS("gps");
        gps.enable(Misc.CONTROL_STEP*2);
        Compass compass = robot.getCompass("compass");
        compass.enable(Misc.CONTROL_STEP*2);
        
        // init actuators
        
        // setup behaviors
        avoid = new Avoid(ds);
        recharge = new Recharge(robot, gps);
        attract = new Attract(gps, compass);
        wander = new Wander(2);
        coordDrive = new PriorityCoord<Drive.Speed>(3);
        drive = new Drive(robot);
        
        WinnerInspector winDrive = new WinnerInspector("Drive", "avoid", "attract", "wander");
        coordDrive.get_winner().connectTo(winDrive.getInputPort());
        
        // run controller
        connectAndRun(robot, Misc.CONTROL_STEP, Misc.RANDOM);
        
        winDrive.dispose();
    }
    
}
